<?php
// $Id: calendar9.inc.php,改造ver. 2016/02/19
//
// * calendar3を改造しました。
// http://www.sakasama.com/dive/
// Karino Taro

// * calendar9を改造しました。
// http://www.kyusan-u.ac.jp
// Koichi Inoue


// 週の開始日 0:日 1:月 2:火 3:水 4:木 5:金 6:土
define('BEGINNING_DAY_OF_WEEK', 0);

function plugin_calendar9_convert()
{
	global $vars, $post, $get, $weeklabels;
	global $_calendar9_plugin_edit, $_calendar9_plugin_empty;
	$script = get_script_uri();

	$date_str = get_date('Ym');
	$base = $vars['page'];
	$beginningDayOfWeek = BEGINNING_DAY_OF_WEEK;

	// パラメータ解析
	$today_view = TRUE;
	if (func_num_args() > 0) {
		$args = func_get_args();
		foreach ($args as $arg) {
			if (is_numeric($arg) && strlen($arg) == 6) {
				$date_str = $arg;
			}else if ($arg == 'off') {
				$today_view = FALSE;
			}else if (is_numeric($arg) && strlen($arg) == 1) {
				$beginningDayOfWeek = $arg;
			}else {
				$base = strip_bracket($arg);
			}
		}
	}

	$this_weeklabels = array_merge(array_slice($weeklabels, $beginningDayOfWeek, 7 - $beginningDayOfWeek), array_slice($weeklabels, 0, $beginningDayOfWeek));
	$diffday = 7 - $beginningDayOfWeek;

	if ($base == '*') {
		$base = '';
		$prefix = '';
	}
	else {
		$prefix = $base.'/';
	}
	$r_base = rawurlencode($base);
	$s_base = htmlspecialchars($base);

	$yr = substr($date_str,0,4);
	$mon = substr($date_str,4,2);

	if ($yr != get_date('Y') || $mon != get_date('m')) {
		$now_day = 1;
		$other_month = 1;
	}
	else {
		$now_day = get_date('d');
		$other_month = 0;
	}

	// 休日読み込み
	//
	//  フォーマット例）
	//    // コメント行
	//    yyyymmdd,タイトル,スタイル
	//    mmdd,タイトル,スタイル
	//
	//  スタイル
	//    0:祝日、休日 1:記念日(タイトルのみ) 2:土曜スタイル
	//
	$dayoff_list = array();
	$day_type = array();		// 0:祝日、休日 1:記念日(タイトルのみ) 2:土曜スタイル
	$day_title = array();
	$page = $prefix.'DayOff';
	$s_page = htmlspecialchars($page);
	foreach (get_source($s_page) as $line) {
		$line = rtrim($line, "\n");
		$d = explode(",", $line, 4);
		$d = array_map('trim', $d);
		if (isset($d[0]) && preg_match('/^\d{4,8}$/', $d[0])) {
			$dayoff_list[] = $d[0];
		}
		else {
			continue;
		}
		if (isset($d[2]) && preg_match('/^\d$/', $d[2])) {
			$day_type[$d[0]] = $d[2];
		}
		else {
			$day_type[$d[0]] = 0;
		}
		if (isset($d[1])) {
			$day_title[$d[0]] = htmlspecialchars($d[1], ENT_QUOTES);
		}
		else {
			$day_title[$d[0]] = 'no value';
		}
	}

	$today = getdate(mktime(0,0,0,$mon,$now_day,$yr) - LOCALZONE + ZONETIME);

	$m_num = $today['mon'];
	$d_num = $today['mday'];
	$year = $today['year'];

	$f_today = getdate(mktime(0,0,0,$m_num,1,$year) - LOCALZONE + ZONETIME);
	$wday = $f_today['wday'];
	$day = 1;

	$m_name = "$year.$m_num";

	$y = substr($date_str,0,4) + 0;
	$m = substr($date_str,4,2) + 0;

	$prev_month_str = ($m == 1) ?
		sprintf('%04d%02d',$y - 1,12) : sprintf('%04d%02d',$y,$m - 1);

	$next_month_str = ($m == 12) ?
		sprintf('%04d%02d',$y + 1,1) : sprintf('%04d%02d',$y,$m + 1);

	//$prev_year_str = sprintf('%04d%02d',$y - 1, $m);
	//$next_year_str = sprintf('%04d%02d',$y + 1, $m);

	$ret = '';

	$ret .= <<<EOD

   <table class="style_calendar" cellspacing="1" width="100%" border="0" summary="calendar body">
    <tr>
     <td class="style_td_caltop" colspan="7">
      <a  href="$script?plugin=calendar9&amp;file=$r_base&amp;date=$prev_month_str&amp;week=$beginningDayOfWeek">PREV.　</a>
      <strong>$m_name</strong>
      <a  href="$script?plugin=calendar9&amp;file=$r_base&amp;date=$next_month_str&amp;week=$beginningDayOfWeek">　NEXT</a>

EOD;
	//カレンダーのページタイトル 不要のためコメントアウト
	//if ($prefix) {
	//	$ret .= "\n      <br />[<a href=\"$script?$r_base\">$s_base</a>]";
	//}
	//<a  href="$script?plugin=calendar9&amp;file=$r_base&amp;date=$prev_year_str&amp;week=$beginningDayOfWeek">PrevYear　</a>
	//<a  href="$script?plugin=calendar9&amp;file=$r_base&amp;date=$next_year_str&amp;week=$beginningDayOfWeek">　NextYear</a>

	$ret .= "\n     </td>\n    </tr>\n    <tr>\n";

	// 曜日ヘッダー
	foreach($this_weeklabels as $label) {
		$ret .= "     <td class=\"style_td_week\">$label</td>\n";
	}

	$ret .= "    </tr>\n    <tr>\n";
	// Blank
//	for ($i = 0; $i < ($wday + $diffday) % 7; $i++) {
//		$ret .= "     <td class=\"style_td_blank\">&nbsp;</td>\n";
//	}

	$tm = mktime(0, 0, 0, $m_num, $day, $year);
	$prev_month = false;
	if(($wday + $diffday) % 7 > 0) {
		$prev_month = true;
		$tm -= (($wday + $diffday) % 7) * 86400;

		$year = date("Y", $tm);
		$m_num = date("n", $tm);
		$day = date("j", $tm);
		$wday = (7 - $diffday) % 7;
	}

	$next_month = false;
	while (true) {
		// 次の月のデータを処理
		if(checkdate($m_num,$day,$year) === false) {
			if($prev_month === true) {
				$prev_month = false;
			}
			else {
				$next_month = true;
			}
			$day = 1;
			$m_num++;
			if($m_num > 12) {
				$m_num = 1;
				$year++;
			}
		}
		if(($next_month == true) && (($wday + $diffday) % 7 == 0)) {
			break;
		}
		$dt = sprintf('%4d-%02d-%02d', $year, $m_num, $day);
		$dtnum = $year * 10000 + $m_num * 100 + $day;
		$dtkey = '';
		$titlecolor = '';
		$page = $prefix.$dt;
		$r_page = rawurlencode($page);
		$s_page = htmlspecialchars($page);
		$href = $script . '?cmd=read&amp;page=' . $r_page;

		if ((($wday + $diffday) % 7 == 0) && ($day > 1)) {
			$ret .= "    </tr>\n    <tr>\n";
		}

		// バックカラーの設定
		$style = 'style_td_day';		// Weekday

		$matchMonthDay = false;
		$matchFull = false;
		if (array_search(substr($dtnum, -4), $dayoff_list) !== false) {
			$matchMonthDay = true;
			$dtkey = substr($dtnum, 4, 4);
		}
		if(array_search($dtnum, $dayoff_list) !== false) {
			$matchFull = true;
			$dtkey = $dtnum;
		}

		if ($wday == 0) {		// Sunday
			$style = 'style_td_sun';
		}
		if ($wday == 6) {		//  Saturday is_page
			$style = 'style_td_sat';
		}
		if ($matchFull == true || $matchMonthDay == true) {		// Day-Off
			if ($day_type[$dtkey] == 0) {
				$style = 'style_td_sun';
				$titlecolor = 'red';
			}
			else if ($day_type[$dtkey] == 2) {
				$style = 'style_td_sat';
				$titlecolor = 'green';
			}
			else {
				$titlecolor = 'black';
			}
		}
		if (!$other_month && ($day == $today['mday']) && ($m_num == $today['mon']) && ($year == $today['year'])) {		// Today
			$style = 'style_td_today';
		}

		// 日付へのリンク
		if (is_page($page)) {
			$link = "<a href=\"$script?$r_page\" title=\"$s_page\"><strong>$day</strong></a>";
		}
		else {
			$link = "<a class=\"small\" href=\"$script?cmd=edit&amp;page=$r_page\" title=\"$s_page\">$day</a>";
			//デフォルトでの元ページへのリンクは無しにしました。
		}


		// 各日付のタイトルを取得してタイトルのみ出力する
		$strr = "";
		if(array_key_exists($dtkey, $day_title)) {
			$strr = '<font color="' . $titlecolor . '">' . $day_title[$dtkey] . "</font><br />\n";
		}
		$matches = array();
		$ids = array();
		$titles = array();
		$subtitles = array();
		$i = 0;
		// タイトルと内容の取得を行う
		$freeze = -1;
		foreach (get_source($s_page) as $line) {
			if($freeze == -1) {
				if(strncmp($line, "#freeze", 7) == 0) {
					$freeze = 1;
				}
				else {
					$freeze = 0;
				}
			}
			if( preg_match('/^(\*{1,3})/', $line, $matches) ) {
				$level = strlen($matches[1]);
				if($level == 1) {
					$id = make_heading($line);
					$ids[$i] = $id;
					if(mb_strlen($line)>6){
						$titles[$i] = mb_substr($line,0,6); // 6文字切り出し
					}else{
						$titles[$i] = $line;
					}
					++$i;
				}
			}
			// サブタイトルまでは表示しないので、以下はコメントアウト 2016.02.19
			//else if (preg_match('/^(\-{1,3})/', $line, $matches) ) {
			//	$level = strlen($matches[1]);
			//	if(($level == 1) && ($i - 1 >= 0) && !isset($subtitles[$i - 1])) {
			//		$subtitles[$i - 1] = $line;
			//	}
			//}
		}

		// ボックスに入れるテキストを作成する。
		for($i = 0; $i < min( count($ids), 3) ; $i++) {
			$linkstr =$titles[$i].'<br>'."\n";
			// サブタイトルまでは表示しないので、以下はコメントアウト 2016.02.19
			//if(isset($subtitles[$i]) && $subtitles[$i] != "") {
			//	$linkstr .= $subtitles[$i] . '<br />';
			//}
			$strr .=$linkstr;
		}

		if( 3 < count($ids)) {
			$linkstr = '<a style="font-weight:bold;" href="' . $href . '#' . $ids[$i] . '">' . 他.strval(count($ids)-3).件. '</a><br />'."\n";
			$strr .= $linkstr;
		}

		//
		$ret .= "     <td class=\"$style\" ref=\"over\" name=\"$base/$dt\" freeze=\"$freeze\"  id=\"$dt\" valign=\"top\" width=\"100\">\n      $link <div class=\"style_td_eventSummary\" align=\"left\">$strr</div>\n     </td>\n";
		$day++;
		$wday = ++$wday % 7;
	}

	$ret .= "    </tr>\n   </table>\n";

	if ($today_view) {
		$tpage = $prefix . sprintf('%4d-%02d-%02d', $today['year'],
			$today['mon'], $today['mday']);
		$r_tpage = rawurlencode($tpage);
		if (is_page($tpage)) {
			$_page = $vars['page'];
			$get['page'] = $post['page'] = $vars['page'] = $tpage;
			$str = convert_html(get_source($tpage));
			$str .= '<hr /><a class="small" href="' . $script .
				'?cmd=edit&amp;page=' . $r_tpage . '">' .
				$_calendar9_plugin_edit . '</a>';
			$get['page'] = $post['page'] = $vars['page'] = $_page;
		} else {
			$str = sprintf($_calendar9_plugin_empty,
				make_pagelink(sprintf('%s%4d-%02d-%02d', $prefix,
				$today['year'], $today['mon'], $today['mday'])));
		}
		$ret .= '<br /><br /><p><strong>' . $today['year'] .' / ' . $today['mon'] .' / '. $today['mday'] . '</strong></p>' . $str . '<br /><br />';
	}

	return $ret;
}

function plugin_calendar9_action()
{
	global $vars;


	$page = $vars['page'];
	$vars['page'] = '*';
	if (isset($vars['file']) && $vars['file'] != '') {
		$vars['page'] = $vars['file'];
	}

	$date = $vars['date'];

	if (isset($vars['date']) && $vars['date'] != '') {
		$date = $vars['date'];
	}
	else {
		$date = get_date("Ym");
	}
	$yy = sprintf("%04d.%02d",substr($date,0,4),substr($date,4,2));

	$sweek = BEGINNING_DAY_OF_WEEK;
	if (isset($vars['week'])) {
		$sweek = $vars['week'];
	}

	$aryargs = array($vars['page'], $date, $sweek);
	$s_page = htmlspecialchars($vars['page']);

	$ret['msg'] = "calendar $s_page/$yy";
	$ret['body'] = call_user_func_array('plugin_calendar9_convert',$aryargs);

	$vars['page'] = $page;

	return $ret;
}

?>
